︠b02177d6-d522-43fe-bed6-03caefd954a4s︠
def lefthand_rs(fcn,a,b,n):
	# output: left-hand riemann sum approx of int_a^n fcn(x)dx using n steps
	Deltax = (b-a)*1.0/n
	return Deltax*sum([f(a+Deltax*i) for i in range(n)])

#Example
n=5
f(x)=e^(-x)
print lefthand_rs(f(x),0,1,n).n();
︡5575ea17-2ca2-41bf-84ef-5e686d331b15︡{"stdout":"0.697438279864974"}︡{"stdout":"\n"}︡{"done":true}︡
︠a931683b-c873-4458-98ef-4262290906b5s︠


def righthand_rs(fcn,a,b,n):
# output: right-hand riemann sum approx of int_a^b fcn(x)dx using n steps
	Deltax = (b-a)*1.0/n
	return Deltax*sum([f(a+Deltax*(i+1)) for i in range(n)])

#Example
n=5
f(x)=x^2
print righthand_rs(f(x),0,1,n).n();
︡97137139-e9b7-41ac-9537-1ee37e454d14︡{"stdout":"0.440000000000000\n"}︡{"done":true}︡
︠c5ba1fb5-b72e-4122-af17-1b2760048030s︠

def midpoint_rule(fcn,a,b,n):
# output: midpoint rule approx of int_a^b fcn(x)dx using n steps
	Deltax = (b-a)*1.0/n
	xs=[a+Deltax*i for i in range(n+1)]
	ysmid=[f((xs[i]+xs[i+1])/2) for i in range(n)]
	return Deltax*sum(ysmid)

#Example
n=5;
f(x)=x*x
print midpoint_rule(f(x),0,1,n).n();
︡64420b6c-c277-48d1-a1a5-58f5816ee293︡{"stdout":"0.330000000000000\n"}︡{"done":true}︡
︠ef7682d6-7fa4-40e8-81c4-cd87d3b2c6b5s︠

f(x) = x^2
f = Piecewise([[(0,1), f]])
g = f.riemann_sum(300, mode="right")
F = f.plot(color="blue")
R= add([line([[a,0],[a,f(x=a)],[b,f(x=b)],[b,0]], color="red") for (a,b), f in g.list()])
show(F+R)
︡a51b4e09-fd6e-43a4-88f5-b9afa529b1ad︡{"file":{"filename":"/home/user/.sage/temp/project-8f86bbe7-5512-45ab-a512-42061da67599/338/tmp_GafeS7.svg","show":true,"text":null,"uuid":"52d50028-46b8-445d-b842-1912397b7ff0"},"once":false}︡{"done":true}︡
︠2f21fc50-7ac5-4496-b3a9-075cd23f47e1s︠


def trapezoid_rule(fcn,a,b,n):
# output: trapezoid rule approx of int_a^b fcn(x)dx using n steps
	Deltax = (b-a)*1.0/n
	coeffs = [2]*(n-1)
	coeffs = [1]+coeffs+[1]
	valsf = [f(a+Deltax*i) for i in range(n+1)]
	return (Deltax/2)*sum([coeffs[i]*valsf[i] for i in range(n+1)])

#Example
n=10;
f(x)=1/x
print trapezoid_rule(f(x),1,2,n).n();
︡79dbf906-3516-451c-a681-296f0cfef30d︡{"stdout":"0.693771403175428"}︡{"stdout":"\n"}︡{"done":true}︡
︠8c17391f-5857-414d-89a4-18bf722e5436s︠


x = var('x') 
f1(x) = e^(x^2) 
f = Piecewise([[(0,1),f1]]) 
trapezoid_sum = f.trapezoid(5) 
P = f.plot(rgbcolor=(0,0,1), plot_points=40)
Q = trapezoid_sum.plot(rgbcolor=(1,0,0), plot_points=40) 
L = add([line([[a,0],[a,f(x=a)]], rgbcolor=(1,0,0)) for (a,b), f in trapezoid_sum.list()])
M = line([[1,0],[1,f1(1)]], rgbcolor=(1,0,0)) 
show(P + Q + L + M)
︡56a8413c-8b82-4b20-aa90-bc3384837a25︡{"file":{"filename":"/home/user/.sage/temp/project-8f86bbe7-5512-45ab-a512-42061da67599/116/tmp_uSV6YZ.svg","show":true,"text":null,"uuid":"f9d68b51-69f0-4ff2-a38a-fcd6c77b09eb"},"once":false}︡{"done":true}︡
︠163d9c99-bc0f-46d5-ad19-7d6db2a70a3ds︠

def simpsons_rule(fcn,a,b,n):
# output: simpsons rule approx of int_a^b fcn(x)dx using n steps (n must be an even integer)
	Deltax = (b-a)*1.0/n
	n2=int(n/2)
	coeffs = [4,2]*n2
	coeffs = [1] +coeffs[:n-1]+[1]
	valsf = [f(a+Deltax*i) for i in range(n+1)]
	return (Deltax/3)*sum([coeffs[i]*valsf[i] for i in range(n+1)])

#Example
n=7;
f(x)=1/x
print simpsons_rule(f(x),1,2,n).n();
︡396e5a8e-f44d-4768-8e6a-5a1982a9f265︡{"stdout":"0.668501868501868\n"}︡{"done":true}︡










